//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------
//Hands on vehicle script by lordician
exec("./support_HandsOnVehicle.cs");
// Load dts shapes and merge animations
datablock TSShapeConstructor(Ninja_BikeDts)
{
	baseShape  = "./ninja_bike.dts";
	sequence0  = "./b_root.dsq root";

	sequence1  = "./b_forward.dsq run";
	sequence2  = "./b_forward.dsq walk";
	sequence3  = "./b_left.dsq back";
	sequence4  = "./b_root.dsq side";

	sequence5  = "./b_root.dsq crouch";
	sequence6  = "./b_forward.dsq crouchRun";
	sequence7  = "./b_left.dsq crouchBack";
	sequence8  = "./b_root.dsq crouchSide";

	sequence9  = "./b_root.dsq look";
	sequence10 = "./b_root.dsq headside";
	sequence11 = "./b_root.dsq headUp";

	sequence12 = "./b_jump.dsq jump";
	sequence13 = "./b_jump.dsq standjump";
	sequence14 = "./b_root.dsq fall";
	sequence15 = "./b_root.dsq land";

	sequence16 = "./b_root.dsq armAttack";
	sequence17 = "./b_root.dsq armReadyLeft";
	sequence18 = "./b_root.dsq armReadyRight";
	sequence19 = "./b_root.dsq armReadyBoth";
	sequence20 = "./b_root.dsq spearready";  
	sequence21 = "./b_root.dsq spearThrow";

	sequence22 = "./b_root.dsq talk";  

	sequence23 = "./b_root.dsq death1"; 
	
	sequence24 = "./b_root.dsq shiftUp";
	sequence25 = "./b_root.dsq shiftDown";
	sequence26 = "./b_root.dsq shiftAway";
	sequence27 = "./b_root.dsq shiftTo";
	sequence28 = "./b_root.dsq shiftLeft";
	sequence29 = "./b_root.dsq shiftRight";
	sequence30 = "./b_root.dsq rotCW";
	sequence31 = "./b_root.dsq rotCCW";

	sequence32 = "./b_root.dsq undo";
	sequence33 = "./b_root.dsq plant";

	sequence34 = "./b_root.dsq sit";

	sequence35 = "./b_root.dsq wrench";

   sequence36 = "./b_root.dsq activate";
   sequence37 = "./b_root.dsq activate2";

   sequence38 = "./b_root.dsq leftrecoil";
};


//datablock AudioProfile(Ninja_BikeJumpSound)
//{
//   fileName = "./jump.wav";
//   description = AudioClose3d;
//   preload = true;
//};


datablock DebrisData( Ninja_BikeDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(Ninja_BikeArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./Ninja_Bike.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 80;
   drag = 0.1;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 33;
   maxBackwardSpeed = 3;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 40;
   maxBackwardCrouchSpeed = 2;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 40;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 40;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 6 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1 1 1.2", 4);
   crouchBoundingBox	= vectorScale("1 1 1.2", 4);
   
   pickupRadius = 0.75;
   
  
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 40;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= Ninja_BikeJumpSound;


   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Ninja Bike";
	rideable = true;
		lookUpLimit = 0.70;
		lookDownLimit = 0.71;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = Ninja_BikeBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "armreadyboth";
   //mountNode[0] = 2;
   
   handsOnVehicle = 1;
};



function Ninja_BikeArmor::onAdd(%this,%obj)
{
	Parent::onAdd(%this, %obj);
   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRepairRate(0);

}



//called when the driver of a player-vehicle is unmounted
function Ninja_BikeArmor::onDriverLeave(%obj, %player)
{
	//do nothing
}